package com.link.core.thread;

import com.link.core.basic.thread.LinkThreadPoolExecutor;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;

public class ThreadPoolExecutorSingleton {
   private static volatile ThreadPoolExecutor instance;
   private static volatile LinkThreadPoolExecutor contextInstance;
   private static final int CORE_POOL_SIZE = 16;
   private static final int MAXIMUM_POOL_SIZE = 128;
   private static final Long KEEP_ALIVE_TIME = 60L;

   public static ThreadPoolExecutor getInstance() {
      if (null == instance) {
         Class var0 = ThreadPoolExecutorSingleton.class;
         synchronized(ThreadPoolExecutorSingleton.class) {
            if (null == instance) {
               instance = new ThreadPoolExecutor(16, 128, KEEP_ALIVE_TIME, TimeUnit.MILLISECONDS, new LinkedBlockingQueue(512), Executors.defaultThreadFactory());
            }
         }
      }

      return instance;
   }

   public static ThreadPoolExecutor getContextInstance() {
      if (null == contextInstance) {
         Class var0 = ThreadPoolExecutorSingleton.class;
         synchronized(ThreadPoolExecutorSingleton.class) {
            if (null == contextInstance) {
               contextInstance = new LinkThreadPoolExecutor(16, 128, KEEP_ALIVE_TIME, TimeUnit.MILLISECONDS, new LinkedBlockingQueue(10240), Executors.defaultThreadFactory());
            }
         }
      }

      return contextInstance;
   }
}
